/*
CLASSE CL_option

Cette classe comporte deux proprits:
- num_theme:
Indique le numro du thme choisi.
- nb_questions:
Indique le nombre de questions  poser.
*/
function CL_option() {
  this.num_theme=0;
  this.nb_questions=20;
}

/*
CLASSE CL_activite

Cette classe comporte deux proprits:
- num:
Indique le numro de la question et des rponses en cours.
- nb_faites:
Indique le nombre de questions qui ont dj t poses.

Elle comporte une mthode:
- commentaire():
Retourne une apprciation selon la rponse propose par l'utilisateur.
*/
function CL_activite() {
  this.num=0;
  this.nb_faites=0;
  this.commentaire=commentaire;
}
function commentaire(cas) {
  if (cas=="vrai") {
    var nb=Math.floor(7*Math.random());
    if (nb==0) return "Oui!";
    if (nb==1) return "Exact!";
    if (nb==2) return "Juste!";
    if (nb==3) return "Vrai!";
    if (nb==4) return "Bien!";
    if (nb==5) return "Excellent!";
    if (nb==6) return "Parfait!";
  }
  else if (cas=="faux") {
    var nb=Math.floor(4*Math.random());
    if (nb==0) return "Non...";
    if (nb==1) return "Faux...";
    if (nb==2) return "Erreur...";
    if (nb==3) return "Inexact...";
  }
}

/*
CLASSE CL_evaluation

Cette classe comporte trois proprits:
- debut:
Indique le moment o l'utilisateur commence  rpondre aux questions.
- fin:
Indique le moment o l'utilisateur cesse de rpondre aux questions.
- note:
Indique la note sur 20.

Elle comporte une mthode:
- appreciation():
Retourne une apprciation selon le travail effectu par l'utilisateur.
*/
function CL_evaluation() {
  this.debut=null;
  this.fin=null;
  this.note=0;
  this.appreciation=appreciation;
}
function appreciation(notesur20,exercice) {
  if (exercice=="termine") {
    if (notesur20>=16) return "C'est trs bien!";
    if (notesur20<16 && notesur20>=13) return "Bon travail!";
    if (notesur20<13 && notesur20>=10) return "Ensemble moyen.";
    if (notesur20<10 && notesur20>=6) return "Vous pourriez revoir votre cours, puis tenter  nouveau ce qcm.";
    if (notesur20<6) return "Ne vous dcouragez pas! Etudiez votre cours avant de retenter ce qcm.";
  }
  else return "Vous avez quitt le QCM avant d'avoir rpondu  toutes les questions!";
}

/*
CLASSE CL_reponse

Cette classe comporte deux proprits:
- enonce:
Indique l'nonc de la rponse.
- resultat:
Indique si l'nonc est correct ou non, prend les valeurs "vrai" ou "faux".
*/
function CL_reponse(txt) {
  var pos=txt.indexOf("//");
  this.enonce=txt.substring(0,pos);
  this.resultat=txt.substring(pos+2,txt.length);
}

/*
CLASSE CL_question

Cette classe comporte deux proprits:
- etat:
Indique l'etat de la question, prend les valeurs "libre", "affichee" ou "corrigee".
- enonce:
Indique l'nonc de la question.

Elle comporte un tableau:
- reponse[]:
Contient les rponses possibles associes  la question.

Elle comporte une mthodes:
- ajouter_reponse(txt):
Ajoute au tableau reponse[] un nouvel objet instance de la classe CL_reponse.
*/
function CL_question(txt) {
  this.etat="libre";
  this.enonce=txt;
  this.reponse=new Array();
  this.ajouter_reponse=ajouter_reponse;
}
function ajouter_reponse(txt) {
  this.reponse[this.reponse.length]=new CL_reponse(txt);
}

/*
CLASSE CL_theme

Cette classe comporte une proprit:
- titre:
Indique le titre du theme.

Elle comporte un tableau:
- question[]:
Contient les questions disponibles associes au thme.

Elle comporte une mthode:
- ajouter_question(txt):
Ajoute au tableau question[] un nouvel objet instance de la classe CL_question.
*/
function CL_theme(txt) {
  this.titre=txt;
  this.question=new Array();
  this.ajouter_question=ajouter_question;
}
function ajouter_question(txt) {
  this.question[this.question.length]=new CL_question(txt);
}

/*
CLASSE CL_qcm

Cette classe comporte sept proprits:
- presentation:
Indique la prsentation choisie, prend les valeurs "parchemin" ou "azur".
- titre:
Indique le titre du QCM.
- texte:
Indique le texte du QCM.
- commentaire:
Indique un commentaire sur le QCM.
- avertissement:
Sert  afficher un messsage aprs le choix des options et juste avant que ne commence le qcm.
- num_page:
Indique le numro de la page qui doit tre affiche, prend les valeurs 1, 2 ou 3.
- timer:
Sert au clignotement des rponses justes lorsque l'utilisateur s'est tromp.

Elle comporte deux tableaux:
- theme[]:
Contient les thmes disponibles pour ce qcm.
- nombre_questions[]:
Contient les nombres de questions qu'il est possible de choisir pour ce qcm.

Elle comporte trois objets:
- L'objet option instance de la classe CL_option.
- L'objet activite instance de la classe CL_activite.
- L'objet evaluation instance de la classe CL_evaluation.
*/
function CL_qcm() {
  this.presentation="parchemin";
  this.titre="";
  this.texte="";
  this.commentaire="";
  this.avertissement="";
  this.num_page=1;
  this.timer=null;
  this.theme=new Array();
  this.nombre_questions=new Array();
  this.option=new CL_option;
  this.activite=new CL_activite;
  this.evaluation=new CL_evaluation;
  this.ajouter_theme=ajouter_theme;
}
function ajouter_theme(txt) {
  this.theme[this.theme.length]=new CL_theme(txt);
}


// CREATION DE L'OBJET qcm

var qcm=new CL_qcm();
